/* Copyright 2022, Michele Santullo
 * This file is part of duckticker.
 *
 * Wrenpp is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Wrenpp is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with duckticker.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "ticker_price.hpp"

namespace wren {
class VM;
} //namespace wren

namespace duck {
enum class BitcoinityMatchType {
	Any,
	Exact,
	CurrencyOnly,
	ExchangeOnly
};

extern const std::string_view g_bitcoinity_wren_module;

TickerPrice bitcoinity_ticker_price (
	std::string_view exchange,
	std::string_view currency,
	BitcoinityMatchType match_type
);

void register_bitcoinity_to_wren (wren::VM& vm);
} //namespace duck
