/* Copyright 2022, Michele Santullo
 * This file is part of duckticker.
 *
 * Wrenpp is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Wrenpp is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with duckticker.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include <string>

namespace wren {
class VM;
} //namespace wren

namespace duck {
class TickerPrice {
public:
	TickerPrice() = default;
	TickerPrice (double price, std::string&& currency, std::string&& exchange);

	void set_price (double price);
	void set_currency (std::string&& currency);
	void set_exchange (std::string&& exchange);
	double price() const noexcept;
	const char* currency() const noexcept;
	const char* exchange() const noexcept;
	bool is_valid() const noexcept;

private:
	double m_price{};
	std::string m_currency;
	std::string m_exchange;
};

extern const std::string_view g_ticker_price_wren_module;

void register_ticker_price_to_wren(wren::VM& vm);
} //namespace duck
