/* Copyright 2022, Michele Santullo
 * This file is part of duckticker.
 *
 * Wrenpp is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Wrenpp is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with duckticker.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include <string>
#include <string_view>
#include <optional>
#include <memory>

namespace duck {
class WebsocketReader {
public:
	static const std::string_view BeastVersionString;

	WebsocketReader (std::string host,
		const std::string& port,
		const std::string& path,
		const std::string& user_agent
	);

	~WebsocketReader();

	std::string read();
	void write(const std::string_view& message);

private:
	struct LocalData;
	std::unique_ptr<LocalData> m_local;
};

} //namespace duck
