/* Copyright 2022, Michele Santullo
 * This file is part of duckticker.
 *
 * Wrenpp is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Wrenpp is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with duckticker.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "bitcoinity_payload.hpp"

namespace duck {
BitcoinityPayload::BitcoinityPayload(
	simdjson::padded_string&& body,
	simdjson::ondemand::parser&& parser
) :
	m_body(std::move(body)),
	m_parser(std::move(parser)), //moving parser invalidates the document
	m_document(m_parser.iterate(m_body)),
	m_payload_node(m_document[JsonKeyPayload])
{
}

BitcoinityPayload::BitcoinityPayload(BitcoinityPayload&& other) :
	BitcoinityPayload(std::move(other.m_body), std::move(other.m_parser))
{
}

BitcoinityPayload& BitcoinityPayload::operator= (BitcoinityPayload&& other) {
	m_body = std::move(other.m_body);
	m_parser = std::move(other.m_parser);
	m_document = m_parser.iterate(m_body);
	m_payload_node = m_document[JsonKeyPayload];
	return *this;
}

} //namespace duck
